// 문제 자체가 처음 보면 굉장히 막막하게 만드는 경향이 있는 문제 스타일이다.
// 이 문제는 일반적으로 DP 나 완전탐색으로 풀 수 있다.
// 먼저의 경우는 완전탐색으로 풀어보았다.
// 완전탐색의 핵심은 재귀용법이다.
// 재귀용법의 핵심은 최종적인 결과를
// 어디로 맺음을 하냐는 문제다
// 이 경우는 최종적인 결과값을 아래로 아래로 보내면서
// 결과를 구하고,
// 그 결과가 원하는 값을 만족시키는 로직을 짜는 것이 효율적이다.
// 이를 위해선
// 1) 반복문 준비, 2) 반복문 속 연산식 나열하기 3) 파라미터 준비하기
// 이렇게 생각할 수 있다.
// 하나씩 설명하면
// 1) 반복문은 각 turn 마다, 진행되어야 하는 주어진 값을 세팅한다고 생각해야한다.
// 따라서 여기서는 N 이 NN NNN 이런식으로 증가하므로
// N 이 주어지는 세팅값이라고 생각해야 한다.
// 따라서 반복문에서 돌아야하는 세팅값은 N 으로 보고,
// 이를 지속적으로 제시해줘야 한다. N NN NNN NNNN 이런식으로
// 2) 반복문 속 연산식 나열하기
// 일반적으로 이 수식은 간단해서 recurv 한줄만 쓰면 되지만
// 알골문제에서는 위에서 제시한 N 에 대해서 여러 연산식을 수행할 것을
// 요청한다. 따라서 N 에 대해 사칙연산 케이스를 제공해주어야 한다.
// 그래서 각 turn 마다 그 모든 사칙연산이 수행되도록 해주어야 한다.
// 그 결과, recurv 문이 각 turn 마다 여러개 나오게 된다.
// 어색할 수 도 있지만, 받아 들여야 한다.
// 3) 파라미터 준비하기
// 이는 recurv 파라미터에 들어갈 값을 세팅하는 것이다.
// 거기에는 주로 터미널 조건, 지속적으로 결과를 내어야하는 값, 문제에서 제공한 조건을
// 주로 넣어야 한다.
// 이런식으로 1) 반복문 세팅하기 2) 반복문 속 연산식 세팅하기 3) 파라미터(터미널, value) 세팅하기
// 준비하면 완전 탐색에 대하여 좋은 결과를 낼 수 있게 된다.

let min = Infinity;
let arr = [];

function recurv(number, nCnt, val) {
  if (nCnt > 8) {
    return;
  } else if (number == val) {
    min = min < nCnt ? min : nCnt;
    return;
  }

  for (let i = 1; i <= 8; ++i) {
    recurv(number, nCnt + i, val + arr[i - 1]);
    recurv(number, nCnt + i, val - arr[i - 1]);
    recurv(number, nCnt + i, val * arr[i - 1]);
    recurv(number, nCnt + i, val / arr[i - 1]);
  }
}

function solution(N, number) {
  arr.push(N);
  for (let i = 1, n = "" + N; i <= 7; ++i) arr.push(Number((n += "" + N)));

  recurv(number, 0, 0);
  return min == Infinity ? -1 : min;
}
